
#include "formlib.h"

/* FORMLIB Versione 2.11 - 1/12/98 */


void SendMIMEHeading(void)

   {printf("Content-type:text/html%c%c",10,10);}


void SendHTMLHeading(char *s)

   {printf("<HTML><HEAD><TITLE>%s</TITLE></HEAD>",s);
    printf("<BODY><H1>%s</H1>",s);}


void SendHTMLTail(void)

   {printf("</BODY></HTML>");}


void SendError(char *s)

   {SendMIMEHeading();
    SendHTMLHeading("Errore di interazione con il server");
    printf("<HR><BR>%s<P>", s);

#ifdef GIVEMAIL
    printf("Se il problema non dipende da voi, potete segnalare l'errore all'indirizzo di posta elettronica ");
    printf("<A HREF=\"mailto:%s\">%s</A> .", MAILADDRESS, MAILADDRESS);
#endif    
    
    SendHTMLTail();
   }


int TypeIsForm(void)

   {char *s;
    s = getenv("CONTENT_TYPE");
    if (strcmp(s, "application/x-www-form-urlencoded"))
       {SendError("Questo programma puo' ricevere input soltanto da una form.");
	return 0;}
    else return 1;
   }


static int HexToDec(char *p)

   {char ch;
    ch = toupper(*p);
    if (ch >= 'A')
	return (ch - 'A' + 10);
    else
	return (ch - '0');
   }


static char UrlDecoded(char **q)

   {if (**q == '%')
       {unsigned int val;
	*q += 2;
	val = HexToDec(*q-1) * 16 + HexToDec(*q);
	return (char) val;
       }
    else if (**q == '+')
	return ' ';
    else
	return **q;
   }


static char StdinUrlDecoded(char ch, int *pcl)

   {if (ch == '%')
       {unsigned int val;
	ch = getchar();
	val = HexToDec(&ch) * 16;
	ch = getchar();
	val += HexToDec(&ch);
	*pcl -= 2;
	return (char) val;
       }
    else if (ch == '+')
	return ' ';
    else
	return ch;
   }


int MethodIsGET(void)

   {char *s;
    s = getenv("REQUEST_METHOD");
    if (s != NULL)
       {if (strcmp(s, "GET"))
	   {SendError("Questo programma deve essere richiamato con il metodo GET.");
	    return 0;}
	else
	    return 1;
       }
    else
       {SendError("Non e' possibile leggere il metodo di accesso dall'ambiente.");
	return 0;
       }
   }


int MethodIsPOST(void)

   {char *s;
    s = getenv("REQUEST_METHOD");
    if (s != NULL)
       {if (strcmp(s, "POST"))
	   {SendError("Questo programma deve essere richiamato con il metodo POST.");
	    return 0;}
	else
	    return 1;
       }
    else
       {SendError("Non e' possibile leggere il metodo di accesso dall'ambiente.");
	return 0;
       }
   }


void GetGETVars(T_LIST *listdesc)

   {char *p;
    p = getenv("QUERY_STRING");   /* Non devo allocare memoria per p, */
    if (p != NULL)                /* punta alla memoria di ambiente!  */
       {while ((*p) != '\0')
	   {char name[MAX_NAME];
	    char value[MAX_VALUE];
	    int i = 0;
	    while ((*p != '=') && (i < MAX_NAME-1))
	       {name[i++] = UrlDecoded(&p);
		p++;}
	    name[i] = '\0';
	    p++;
	    i = 0;
	    while ((*p != '&') && (*p != '\0') && (i < MAX_VALUE-1))
	       {value[i++] = UrlDecoded(&p);
		p++;}
	    value[i] = '\0';
	    ListPutFront(listdesc, name, value);
	    p++;
	   }
       }
    else SendError("Non sono stati forniti dati.");
   }


void GetPOSTVars(T_LIST *listdesc)

   {char *p;
    p = getenv("CONTENT_LENGTH");
    if (p != NULL)
       {int cl;
	cl = atoi(p)+1;
	while (cl)
	   {char name[MAX_NAME];
	    char value[MAX_VALUE];
	    char ch;
	    int i = 0;
	    ch = getchar();
	    cl--;
	    while ((ch != '=') && (i < MAX_NAME-1) && (cl))
	       {name[i++] = StdinUrlDecoded(ch, &cl);
		ch = getchar();
		cl--;} 
	    name[i] = '\0';
	    ch = getchar();
	    cl--;
	    i = 0;
	    while ((ch != '&') && (ch != '\0') && (i < MAX_VALUE-1) && (cl))
	       {value[i++] = StdinUrlDecoded(ch, &cl);
		ch = getchar();
		cl--;}
	    value[i] = '\0';
	    ListPutFront(listdesc, name, value);
	   }
       }
    else SendError("Non sono stati forniti dati.");
   }

